#!/bin/bash

TEMPLATE=$1
ARCH=$2
SED_PARAMS=()

update_param() {
    SED_PARAMS+=("-e" "s/^$1=.*$/$1=\"$2\"/")
}

case "$ARCH" in
    aarch64 )
        update_param KDUMP_COMMANDLINE_APPEND \
            "irqpoll nr_cpus=1 reset_devices cgroup_disable=memory udev.children-max=2 panic=10 swiotlb=noforce novmcoredd cma=0 hugetlb_cma=0"
        ;;
    i386 )
        update_param KDUMP_COMMANDLINE_APPEND \
            "irqpoll nr_cpus=1 reset_devices numa=off udev.children-max=2 panic=10 transparent_hugepage=never novmcoredd cma=0 hugetlb_cma=0"
        ;;
    ppc64 )
        update_param KDUMP_COMMANDLINE_REMOVE \
            "hugepages hugepagesz slub_debug quiet log_buf_len swiotlb hugetlb_cma"
        update_param KDUMP_COMMANDLINE_APPEND \
            "irqpoll maxcpus=1 noirqdistrib reset_devices cgroup_disable=memory numa=off udev.children-max=2 ehea.use_mcs=0 panic=10 kvm_cma_resv_ratio=0 transparent_hugepage=never novmcoredd hugetlb_cma=0"
        update_param KEXEC_ARGS "--dt-no-old-root"
        ;;
    ppc64le )
        update_param KDUMP_COMMANDLINE_REMOVE \
            "hugepages hugepagesz slub_debug quiet log_buf_len swiotlb hugetlb_cma"
        update_param KDUMP_COMMANDLINE_APPEND \
            "irqpoll maxcpus=1 noirqdistrib reset_devices cgroup_disable=memory numa=off udev.children-max=2 ehea.use_mcs=0 panic=10 kvm_cma_resv_ratio=0 transparent_hugepage=never novmcoredd hugetlb_cma=0"
        update_param KEXEC_ARGS "--dt-no-old-root"
        ;;
    s390x )
        update_param KDUMP_COMMANDLINE_REMOVE \
            "hugepages hugepagesz slub_debug quiet log_buf_len swiotlb vmcp_cma cma hugetlb_cma prot_virt"
        update_param KDUMP_COMMANDLINE_APPEND \
            "nr_cpus=1 cgroup_disable=memory numa=off udev.children-max=2 panic=10 transparent_hugepage=never novmcoredd vmcp_cma=0 cma=0 hugetlb_cma=0"
        ;;
    x86_64 )
       update_param KDUMP_COMMANDLINE_APPEND \
           "irqpoll nr_cpus=1 reset_devices cgroup_disable=memory mce=off numa=off udev.children-max=2 panic=10 acpi_no_memhotplug transparent_hugepage=never nokaslr hest_disable novmcoredd cma=0 hugetlb_cma=0 brd.rd_nr=0 nbd.nbds_max=0 pty.legacy_count=0 swiotlb=noforce loop.max_loop=4 audit=0"
        ;;
esac

sed "${SED_PARAMS[@]}" "$TEMPLATE"
